using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;

namespace pmm_01
{
    class TData
    {
   	uint size_row_array,size_col_array;
    double[,] dArray;
    double[] dxArray;
//    TData functPtr;
	double a,b,x0,x1,U_0,N,N_time,total_time,step_x,step_time,kappa,Courant;
	double param_kappa_0,param_kappa_1,param_kappa_b,param_kappa_r0,param_kappa_d,param_kappa_x0;
    public double[] Arra()
    {
        return dxArray;
    }
    public double[] Arrb()
    {
        double [] retArray = new double[size_col_array];
        for (uint j = 0; j < size_col_array; j++)
            retArray[j] = dArray[1, j];
        return retArray;
    }
    public TData()
    {
        dArray  = null;
        dxArray = null;
    }
    public TData(uint sizeRow, uint sizeColumn)
    {
        size_row_array = sizeRow;
        size_col_array = sizeColumn;
        dArray  = new double[sizeRow, sizeColumn];
        dxArray = new double[sizeColumn];
	    for (uint i=0; i < size_row_array; i++)
		    for (uint j=0; j < size_col_array; j++)
    			dArray[i,j]=0;
    }
    ~TData()
    {
    }
//methods
	//void print_result();
    public void begin_value()
    {
        double x;
        for (uint j = 0; j < size_col_array; j++)
        {
            x = a + j * step_x;
            if ((x >= a && x < x0) || (x > x1 && x <= b))
                dArray[0, j] = 0;
            else if (x >= x0 && x <= x1)
                dArray[0, j] = U_0;
            else dArray[0, j] = -1;

        }
    }
    public void init_x_values()
    {
	    for (uint j=0; j < size_col_array; j++){
		    dxArray[j] = (a+step_x*(double)j);
	    }
	    return;
    }
    public void calculate_matrix()
    {
        double Kurant=Courant;
    	for (uint i=1;i<size_row_array;i++)
		    for (uint j=1;j<size_col_array-1;j++)
    			dArray[i,j]=Kurant*dArray[i-1,j+1]+(1-2*Kurant)*dArray[i-1,j]+Kurant*dArray[i-1,j-1];
    	return;
    }
    public void initial_values()
    {
        a=0.0;
	    b=3.0;
	    x0=1.0;
	    x1=2.0;
	    N=size_col_array;
	    N_time=size_row_array;
	    U_0=10.0;
	    kappa=0.001;
	    step_x=(b-a)/N;
	    total_time=(step_x*step_x)*N_time/(2.0001*kappa);
	    step_time=total_time/N_time;
	    Courant=(step_time*kappa)/(step_x*step_x);
	    // values: kappa
	    param_kappa_0=0.001;
	    param_kappa_1=0.001;
	    param_kappa_b=0.002;
	    param_kappa_d=0.001;
	    param_kappa_r0=2.0;
	    param_kappa_x0=1.0;
    }
    public void renew_value()
    {
        for (uint i=(size_row_array-1),j=0;j<size_col_array;j++)
            dArray[0,j]=dArray[i,j];
    }
	//void menu();
	//void enter_values_from_file(string file);
    public void calculate_with_fixed_time(double time, uint kappa_num)
    {
	    for (uint i = 0; time > 0; i++){
    	    calculate_matrix_with_parameter(kappa_num);
	        renew_value();
	        time-=total_time;
	    }
    }
    public void calculate_matrix_with_parameter(uint kappa_num)
    {
	    double F_left, F_right;
	    double max=0.0, max_temp;
	    for (uint j=1, i=1; j < size_col_array - 1 ; j++){
		    max_temp = kappa_choose(kappa_num,(dArray[i-1,j]+dArray[i-1,j-1])/2.0,a+((double)(j-0.5))*step_x);
		    if (max < max_temp) max=max_temp;
	    }
	    total_time=(step_x*step_x)*N_time/(2.0001*max);
	    step_time=total_time/N_time;
	    for (uint i=1;i<size_row_array;i++)
		    for (uint j=1;j<size_col_array-1;j++){
			    F_left      = kappa_choose(kappa_num,(dArray[i-1,j]+dArray[i-1,j-1])/2.0,a+((double)(j-0.5))*step_x)*(dArray[i-1,j]-dArray[i-1,j-1])/step_x;
			    F_right     = kappa_choose(kappa_num,(dArray[i-1,j+1]+dArray[i-1,j])/2.0,a+(((double)j+0.5))*step_x)*(dArray[i-1,j+1]-dArray[i-1,j])/step_x;
			    dArray[i,j] = dArray[i-1,j]+(step_time/step_x)*(F_right-F_left);
		    }
	    return;

    }
	//void debug();

    double kappa_choose(uint number, double U, double x)
    {
        switch (number)
        {
            case 0:
                if (x < 0.5)
                    return 1;
                else
                    return 2;
            case 1:
                return (param_kappa_1 + param_kappa_b * x);// break;
            case 2:
                return (param_kappa_0 * Math.Exp(-((x - param_kappa_x0) * (x - param_kappa_x0) / (param_kappa_r0 * param_kappa_r0))));// break;
            case 3:
                return (param_kappa_0 + param_kappa_d * U);// break;
            default:
                return -1;
        }
    }

    }
}